<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/04/2005 *
 * ===================                          Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_bonus.php                              *
 * -------------------------------------------------------------------- *
 * Short description : List members in active-rallye                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder in Aktiv-Rallye auflisten             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (getConfig('bonus_active') == 'Y') {
	// Shall I withdraw now?
	if (isPostRequestParameterSet(('withdraw'))) {
		// Okay, let's prepare...
		$curr = date('m', time()) - 1;
		if (strlen($curr) == 1) $curr = '0' . $curr;
		updateConfiguration('last_month', $curr);
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_BONUS_WITHDRAW_PREPARED'));
	} // END - if

	if (getExtensionVersion('bonus') >= '0.6.9') {
		// Add more bonus points here
		$USE = '(0';
		if (getConfig('bonus_click_yn') == 'Y') $USE .= ' + `turbo_bonus`';
		if (getConfig('bonus_login_yn') == 'Y') $USE .= ' + `login_bonus`';
		if (getConfig('bonus_order_yn') == 'Y') $USE .= ' + `bonus_order`';
		if (getConfig('bonus_stats_yn') == 'Y') $USE .= ' + `bonus_stats`';
		if (getConfig('bonus_ref_yn')   == 'Y') $USE .= ' + `bonus_ref`';
		$USE .= ')';
	} else {
		// Old version ???
		$USE = 'turbo_bonus';
	}

	// Autopurge installed?
	$lastOnline = "%s"; $ONLINE = '';
	if (isExtensionActive('autopurge')) {
		// Use last online timestamp to keep inactive members away from here
		$lastOnline   = " AND `last_online` >= (UNIX_TIMESTAMP() - %s)";
		$ONLINE = getConfig('ap_inactive_since');
	}

	// Check if at least one is in the active rallye
	$result = SQL_QUERY_ESC("SELECT `userid`, `email`, `gender`, `surname`, `family`, ".$USE." AS points, `last_online`
FROM `{?_MYSQL_PREFIX?}_user_data`
WHERE `status`='CONFIRMED' AND ".$USE." > 0".$lastOnline."
ORDER BY `points` DESC, `last_online` DESC, `userid` ASC",
	array($ONLINE), __FILE__, __LINE__);

	if (SQL_NUMROWS($result) > 0) {
		// List users
		$OUT = '';$SW = 2; $cnt = 1; $total = '0';
		while ($content = SQL_FETCHARRAY($result)) {
			// Add total points
			$total += $content['points'];

			// Generate array fore the dynamic template
			$WIN1 = ''; $WIN2 = '';
			if ($cnt <= getConfig('bonus_ranks')) {
				// Maybe he can win his active bonus?
				$WIN1 = '<strong>';
				$WIN2 = '</strong>';
			} // END - if

			// Prepare content
			$content['userid']    = generateUserProfileLink($content['userid']);
			$content['email']  = generateEmailLink($content['email'], 'user_data');
			$content['gender'] = translateGender($content['gender']);
			$content['points'] = translateComma($content['points']);
			$content['last_online']   = generateDateTime($content['last_online'], 2);
			$content['sw']     = $SW;
			$content['win1']   = $WIN1;
			$content['win2']   = $WIN2;
			$content['cnt']    = $cnt;

			// Load template and add it
			$OUT .= loadTemplate('admin_list_bonus_rows', true, $content);
			$SW = 3 - $SW; $cnt++;
		} // END - while

		$content['rows']  = $OUT;
		$content['total'] = translateComma($total);

		// Check if we need to display form or not with manuel withdraw
		if (getConfig('last_month') == date('m', time())) {
			// Load form
			$content['withdraw_form'] = loadTemplate('admin_list_bonus_form', true);
		} else {
			// Display message "no manual withdraw possible"
			$content['withdraw_form'] = loadTemplate('admin_settings_saved', true, '<div class="admin_failed">{--ADMIN_BONUS_ALREADY_WITHDRAW--}</div>');
		}

		// Prepare constant for timemark
		if (isExtensionActive('autopurge')) {
			$content['autopurge_timeout'] = generateDateTime(time() - getConfig('ap_inactive_since'), 2);
		} else {
			$content['autopurge_timeout'] = loadTemplate('admin_settings_saved', true, getMaskedMessage('EXTENSION_PROBLEM_NOT_INSTALLED', 'autopurge'));
		}

		// Load final template
		loadTemplate('admin_list_bonus', false, $content);
	} else {
		// No one has become an "activity bonus"...
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_BONUS_NO_ACTIVE_RALLYE'));
	}
} else {
	// Aktive-Rallye not activated
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_BONUS_RALLYE_DEACTIVATED'));
}

// [EOF]
?>
